LeetCode 414 - Third Maximum Number


https://leetcode.com/problems/third-maximum-number/
Given a non-empty array of integers, return the third maximum number in this array. If it does not exist, return the maximum number. The time complexity must be in O(n).
Example 1:
Input: [3, 2, 1]

Output: 1

Explanation: The third maximum is 1.
Example 2:
Input: [1, 2]

Output: 2

Explanation: The third maximum does not exist, so the maximum (2) is returned instead.
Example 3:
Input: [2, 2, 3, 1]

Output: 1

Explanation: Note that the third maximum here means the third maximum distinct number.
Both numbers with value 2 are both considered as second maximum.
https://discuss.leetcode.com/topic/63715/java-neat-and-easy-understand-solution-o-n-time-o-1-space
    public int thirdMax(int[] nums) {
        Integer max1 = null;
        Integer max2 = null;
        Integer max3 = null;
        for (Integer n : nums) {
            if (n.equals(max1) || n.equals(max2) || n.equals(max3)) continue;
            if (max1 == null || n > max1) {
                max3 = max2;
                max2 = max1;
                max1 = n;
            } else if (max2 == null || n > max2) {
                max3 = max2;
                max2 = n;
            } else if (max3 == null || n > max3) {
                max3 = n;
            }
        }
        return max3 == null ? max1 : max3;
    }
http://www.jianshu.com/p/e9dfd2494f41
 public int thirdMax (int[] nums) {
     long first = Long.MIN_VALUE;
     long second = Long.MIN_VALUE;
     long third = Long.MIN_VALUE;
     for (int i:nums){
         if (i>first){
             third = second;
             second = first;
             first = i;
         }else if (i == first)     //必要
             continue;
         else if (i > second){
             third = second;
             second = i;
         }else if (i == second)     //必要
             continue;
         else if (i > third){
             third = i;
         }
     }
     return third == Long.MIN_VALUE ? (int)first : (int)third;
       //method 要求返回类型为int,强制转化一下,narrowing conversion
 }
https://discuss.leetcode.com/topic/63671/o-n-time-o-1-space-java-short-solution
    public int thirdMax(int[] nums) {
        long first=Long.MIN_VALUE;
        long second=Long.MIN_VALUE;
        long third=Long.MIN_VALUE;
        for(int i:nums){
            if(i>first){
                third=second;
                second=first;
                first=i;
            }else if(i==first)
                continue;
            else if(i>second){
                third=second;
                second=i;
            }else if(i==second)
                continue;
            else if(i>third){
                third=i;
            }
        }
        return third==Long.MIN_VALUE?(int)first:(int)third;
    }

https://discuss.leetcode.com/topic/62236/java-solution-in-0ms-run-time-o-n-and-space-o-1
Another way to check whether the third maximum number exists is to declare all three numbers as long integer type and initialize them to the corresponding minimum value. Then at last if the third number is still the minimum value of long integer, we know it does not exist (its value will not get updated if it does not exist). Something like this:
public int thirdMax(int[] nums) {
    long max = Long.MIN_VALUE, mid = max, min = max;
        
    for (int ele : nums) {
        if (ele > max) {
            min = mid;
            mid = max;
            max = ele;
        } else if (max > ele && ele > mid) {
            min = mid;
            mid = ele;
        } else if (mid > ele && ele > min) {
            min = ele;
        }
    }
        
    return (int)(min != Long.MIN_VALUE ? min : max);
}

public int thirdMax(int[] nums) {
        int max, mid, small, count;
        max = mid = small = Integer.MIN_VALUE;
        count = 0;  //Count how many top elements have been found.

        for( int x: nums) {
            //Skip loop if max or mid elements are duplicate. The purpose is for avoiding right shift.
            if( x == max || x == mid ) {
                continue;
            }

            if (x > max) {
                //right shift
                small = mid;
                mid = max;

                max = x;
                count++;
            } else if( x > mid) {
                //right shift
                small = mid;

                mid = x;
                count++;
            } else if ( x >= small) { //if small duplicated, that's find, there's no shift and need to increase count.
                small = x;
                count++;
            }
        }

        //"count" is used for checking whether found top 3 maximum elements.
        if( count >= 3) { 
            return small;
        } else {
            return max;
        }
    }
http://bookshadow.com/weblog/2016/10/09/leetcode-third-maximum-number/
利用变量a, b, c分别记录数组第1,2,3大的数字
遍历一次数组即可,时间复杂度O(n)

def thirdMax(self, nums): """ :type nums: List[int] :rtype: int """ a = b = c = None for n in nums: if n > a: a, b, c = n, a, b elif a > n > b: b, c = n, b elif b > n > c: c = n return c if c is not None else a


X. TreeSet
https://discuss.leetcode.com/topic/63903/short-easy-c-using-set/8
  public int thirdMax(int[] nums) {
    TreeSet<Integer> set = new TreeSet<>();
    for(int num : nums) {
      set.add(num);
      if(set.size() > 3) {
        set.remove(set.first());
      }
    }
    return set.size() < 3 ? set.last() : set.first();
  }
https://discuss.leetcode.com/topic/65119/java-solution-using-treeset
    public final int N = 3;
    public int thirdMax(int[] nums) {
        if (nums.length == 0) return 0;

        TreeSet<Integer> set = new TreeSet<Integer>();
        for (int i = 0; i < nums.length; i++) {
            if (set.contains(nums[i])) continue;
            if (set.size() < N || nums[i] > set.first()) {
                if (set.size() == N) set.remove(set.first());
                set.add(nums[i]);
            }
        }
        return set.size() == N ? set.first() : set.last();
    }

http://www.cnblogs.com/grandyang/p/5983113.html
下面这种方法利用了set的自动排序和自动去重复项的特性,很好的解决了问题,对于遍历到的数字,加入set中,重复项就自动去掉了,如果此时set大小大于3个了,那么我们把set的第一个元素去掉,也就是将第四大的数字去掉,那么就可以看出set始终维护的是最大的三个不同的数字,最后遍历结束后,我们看set的大小是否为3,是的话就返回首元素,不是的话就返回尾元素

    int thirdMax(vector<int>& nums) {
        set<int> s;
        for (int num : nums) {
            s.insert(num);
            if (s.size() > 3) {
                s.erase(s.begin());
            }
        }
        return s.size() == 3 ? *s.begin() : *s.rbegin();
    }

X. Use PriorityQueue with HashSet to check duplicate
- Faster than TreeSet as there is no need to keep the elements in the PQ sorted as TreeSet
https://discuss.leetcode.com/topic/63086/java-priorityqueue-o-n-o-1


    public int thirdMax(int[] nums) {
        PriorityQueue<Integer> pq = new PriorityQueue<>();// min heap
        Set<Integer> set = new HashSet<>();
        for (int i : nums) {
            if (!set.contains(i)) {
                pq.offer(i);
                set.add(i);
                if (pq.size() > 3) {
                    set.remove(pq.poll());
                }
            }
        }
        if (pq.size() < 3) {// if there is less than 3, we return the the last one
            while (pq.size() > 1) {
                pq.poll();
            }
        }
        return pq.peek(); // otherwise kth is the first one in the min heap
    }
Related:
http://algorithms.tutorialhorizon.com/find-the-element-which-appears-maximum-number-of-times-in-the-array/
Objec­tive: Given an array of inte­gers, write a algo­rithm to find the ele­ment which appears max­i­mum num­ber of times in the array.
Bet­ter Solu­tion : Use Hashmap. Store the count of each ele­ment of array in a hash table and later check in Hash map which ele­ment has the max­i­mum count 

public void maxRepeatingElementUsingSorting(int [] arrA){
    if(arrA.length<1){
        System.out.println("Inavlid Array");
        return;
    }
    Arrays.sort(arrA);
    int count=1;
    int maxCount=1;
    int currentElement = arrA[0];
    int maxCountElement =arrA[0];
    for (int i = 1; i <arrA.length ; i++) {
        if(currentElement==arrA[i]){
            count++;
        }else{
            if(count>maxCount){
                maxCount = count;
                maxCountElement = currentElement;
            }
            currentElement = arrA[i];
            count = 1;
        }
    }
    System.out.println("Element repeating maximum no of times: " + maxCountElement + ", maximum count: " + maxCount);
}
Bet­ter Solu­tion (Con­di­tional) : O(n) time and O(1) extra space.
  • This solu­tion works only if array has pos­i­tive inte­gers and all the ele­ments in the array are in range from 0 to n-1 where n is the size of the array.
  • Nav­i­gate the array.
  • Update the array as for ith index :- arrA[arrA[i]% n] = arrA[arrA[i]% n] + n;
  • Now nav­i­gate the updated array and check which index has the max­i­mum value, that index num­ber is the ele­ment which has the max­i­mum occur­rence in the array.
public void MaxRepeatingElementInPlace(int [] arrA){
    int size = arrA.length;
    int maxCount=0;
    int maxIndex=0;
    for (int i = 0; i <size ; i++) {
        //get the index to be updated
        int index = arrA[i]% size;
        arrA[index] = arrA[index] + size;
    }
    for (int i = 0; i <size ; i++) {
        if(arrA[i]/size>maxCount){
            maxCount=arrA[i]/size;
            maxIndex=i;
        }
    }
    System.out.println("Element repeating maximum no of times: " + arrA[maxIndex]%size + ", maximum count: " + maxCount);
}

http://algorithms.tutorialhorizon.com/find-duplicates-in-an-given-array-in-on-time-and-o1-extra-space/
Given an array of inte­gers, find out dupli­cates in it.
Bet­ter Solu­tion : Use Hash map. Store the count of each ele­ment of array in a hash table and later check in Hash table if any ele­ment has count more than 1
Bet­ter Solu­tion (Con­di­tional) : O(n) time and O(1) extra space.
  • This solu­tion works only if array has pos­i­tive inte­gers and all the ele­ments in the array are in range from 0 to n-1 where n is the size of the array.
  • Nav­i­gate the array.
  • Update the array as for ith index :- arrA[arrA[i]] = arrA[arrA[i]]*-1 (if it already not negative).
  • If is already neg­a­tive, we have dupli­cates, return false.
Note:
  • The code given below does not han­dle the case when 0 is present in the array.
  • To han­dle 0 in array, while nav­i­gat­ing the array, when 0 is encoun­tered, replace it with INT_MIN and if INT_MIN is encoun­tered while tra­vers­ing, this means 0 is repeated in the array.
public void hasDuplicates(int[] arrA) {

    for (int i = 0; i < arrA.length; i++) {
        //check if element is negative, if yes the we have found the duplicate
        if (arrA[Math.abs(arrA[i])] < 0) {
            System.out.println("Array has duplicates : " + Math.abs(arrA[i]));
        } else {
            arrA[Math.abs(arrA[i])] = arrA[Math.abs(arrA[i])] * -1;
        }
    }
}

Labels

LeetCode (1432) GeeksforGeeks (1122) LeetCode - Review (1067) Review (882) Algorithm (668) to-do (609) Classic Algorithm (270) Google Interview (237) Classic Interview (222) Dynamic Programming (220) DP (186) Bit Algorithms (145) POJ (141) Math (137) Tree (132) LeetCode - Phone (129) EPI (122) Cracking Coding Interview (119) DFS (115) Difficult Algorithm (115) Lintcode (115) Different Solutions (110) Smart Algorithm (104) Binary Search (96) BFS (91) HackerRank (90) Binary Tree (86) Hard (79) Two Pointers (78) Stack (76) Company-Facebook (75) BST (72) Graph Algorithm (72) Time Complexity (69) Greedy Algorithm (68) Interval (63) Company - Google (62) Geometry Algorithm (61) Interview Corner (61) LeetCode - Extended (61) Union-Find (60) Trie (58) Advanced Data Structure (56) List (56) Priority Queue (53) Codility (52) ComProGuide (50) LeetCode Hard (50) Matrix (50) Bisection (48) Segment Tree (48) Sliding Window (48) USACO (46) Space Optimization (45) Company-Airbnb (41) Greedy (41) Mathematical Algorithm (41) Tree - Post-Order (41) ACM-ICPC (40) Algorithm Interview (40) Data Structure Design (40) Graph (40) Backtracking (39) Data Structure (39) Jobdu (39) Random (39) Codeforces (38) Knapsack (38) LeetCode - DP (38) Recursive Algorithm (38) String Algorithm (38) TopCoder (38) Sort (37) Introduction to Algorithms (36) Pre-Sort (36) Beauty of Programming (35) Must Known (34) Binary Search Tree (33) Follow Up (33) prismoskills (33) Palindrome (32) Permutation (31) Array (30) Google Code Jam (30) HDU (30) Array O(N) (29) Logic Thinking (29) Monotonic Stack (29) Puzzles (29) Code - Detail (27) Company-Zenefits (27) Microsoft 100 - July (27) Queue (27) Binary Indexed Trees (26) TreeMap (26) to-do-must (26) 1point3acres (25) GeeksQuiz (25) Merge Sort (25) Reverse Thinking (25) hihocoder (25) Company - LinkedIn (24) Hash (24) High Frequency (24) Summary (24) Divide and Conquer (23) Proof (23) Game Theory (22) Topological Sort (22) Lintcode - Review (21) Tree - Modification (21) Algorithm Game (20) CareerCup (20) Company - Twitter (20) DFS + Review (20) DP - Relation (20) Brain Teaser (19) DP - Tree (19) Left and Right Array (19) O(N) (19) Sweep Line (19) UVA (19) DP - Bit Masking (18) LeetCode - Thinking (18) KMP (17) LeetCode - TODO (17) Probabilities (17) Simulation (17) String Search (17) Codercareer (16) Company-Uber (16) Iterator (16) Number (16) O(1) Space (16) Shortest Path (16) itint5 (16) DFS+Cache (15) Dijkstra (15) Euclidean GCD (15) Heap (15) LeetCode - Hard (15) Majority (15) Number Theory (15) Rolling Hash (15) Tree Traversal (15) Brute Force (14) Bucket Sort (14) DP - Knapsack (14) DP - Probability (14) Difficult (14) Fast Power Algorithm (14) Pattern (14) Prefix Sum (14) TreeSet (14) Algorithm Videos (13) Amazon Interview (13) Basic Algorithm (13) Codechef (13) Combination (13) Computational Geometry (13) DP - Digit (13) LCA (13) LeetCode - DFS (13) Linked List (13) Long Increasing Sequence(LIS) (13) Math-Divisible (13) Reservoir Sampling (13) mitbbs (13) Algorithm - How To (12) Company - Microsoft (12) DP - Interval (12) DP - Multiple Relation (12) DP - Relation Optimization (12) LeetCode - Classic (12) Level Order Traversal (12) Prime (12) Pruning (12) Reconstruct Tree (12) Thinking (12) X Sum (12) AOJ (11) Bit Mask (11) Company-Snapchat (11) DP - Space Optimization (11) Dequeue (11) Graph DFS (11) MinMax (11) Miscs (11) Princeton (11) Quick Sort (11) Stack - Tree (11) 尺取法 (11) 挑战程序设计竞赛 (11) Coin Change (10) DFS+Backtracking (10) Facebook Hacker Cup (10) Fast Slow Pointers (10) HackerRank Easy (10) Interval Tree (10) Limited Range (10) Matrix - Traverse (10) Monotone Queue (10) SPOJ (10) Starting Point (10) States (10) Stock (10) Theory (10) Tutorialhorizon (10) Kadane - Extended (9) Mathblog (9) Max-Min Flow (9) Maze (9) Median (9) O(32N) (9) Quick Select (9) Stack Overflow (9) System Design (9) Tree - Conversion (9) Use XOR (9) Book Notes (8) Company-Amazon (8) DFS+BFS (8) DP - States (8) Expression (8) Longest Common Subsequence(LCS) (8) One Pass (8) Quadtrees (8) Traversal Once (8) Trie - Suffix (8) 穷竭搜索 (8) Algorithm Problem List (7) All Sub (7) Catalan Number (7) Cycle (7) DP - Cases (7) Facebook Interview (7) Fibonacci Numbers (7) Flood fill (7) Game Nim (7) Graph BFS (7) HackerRank Difficult (7) Hackerearth (7) Inversion (7) Kadane’s Algorithm (7) Manacher (7) Morris Traversal (7) Multiple Data Structures (7) Normalized Key (7) O(XN) (7) Radix Sort (7) Recursion (7) Sampling (7) Suffix Array (7) Tech-Queries (7) Tree - Serialization (7) Tree DP (7) Trie - Bit (7) 蓝桥杯 (7) Algorithm - Brain Teaser (6) BFS - Priority Queue (6) BFS - Unusual (6) Classic Data Structure Impl (6) DP - 2D (6) DP - Monotone Queue (6) DP - Unusual (6) DP-Space Optimization (6) Dutch Flag (6) How To (6) Interviewstreet (6) Knapsack - MultiplePack (6) Local MinMax (6) MST (6) Minimum Spanning Tree (6) Number - Reach (6) Parentheses (6) Pre-Sum (6) Probability (6) Programming Pearls (6) Rabin-Karp (6) Reverse (6) Scan from right (6) Schedule (6) Stream (6) Subset Sum (6) TSP (6) Xpost (6) n00tc0d3r (6) reddit (6) AI (5) Abbreviation (5) Anagram (5) Art Of Programming-July (5) Assumption (5) Bellman Ford (5) Big Data (5) Code - Solid (5) Code Kata (5) Codility-lessons (5) Coding (5) Company - WMware (5) Convex Hull (5) Crazyforcode (5) DFS - Multiple (5) DFS+DP (5) DP - Multi-Dimension (5) DP-Multiple Relation (5) Eulerian Cycle (5) Graph - Unusual (5) Graph Cycle (5) Hash Strategy (5) Immutability (5) Java (5) LogN (5) Manhattan Distance (5) Matrix Chain Multiplication (5) N Queens (5) Pre-Sort: Index (5) Quick Partition (5) Quora (5) Randomized Algorithms (5) Resources (5) Robot (5) SPFA(Shortest Path Faster Algorithm) (5) Shuffle (5) Sieve of Eratosthenes (5) Strongly Connected Components (5) Subarray Sum (5) Sudoku (5) Suffix Tree (5) Swap (5) Threaded (5) Tree - Creation (5) Warshall Floyd (5) Word Search (5) jiuzhang (5)

Popular Posts